Index: uspace/srv/net/il/arp/arp.c
===================================================================
--- uspace/srv/net/il/arp/arp.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/il/arp/arp.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -320,5 +320,5 @@
 		/* Bind the new one */
 		device->phone = nil_bind_service(device->service,
-		    (ipcarg_t) device->device_id, SERVICE_ARP,
+		    (sysarg_t) device->device_id, SERVICE_ARP,
 		    arp_globals.client_connection);
 		if (device->phone < 0) {
Index: uspace/srv/net/il/arp/arp_module.c
===================================================================
--- uspace/srv/net/il/arp/arp_module.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/il/arp/arp_module.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -65,5 +65,5 @@
 int il_module_start_standalone(async_client_conn_t client_connection)
 {
-	ipcarg_t phonehash;
+	sysarg_t phonehash;
 	int rc;
 	
Index: uspace/srv/net/il/ip/ip.c
===================================================================
--- uspace/srv/net/il/ip/ip.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/il/ip/ip.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -430,5 +430,5 @@
 	// binds the netif service which also initializes the device
 	ip_netif->phone = nil_bind_service(ip_netif->service,
-	    (ipcarg_t) ip_netif->device_id, SERVICE_IP,
+	    (sysarg_t) ip_netif->device_id, SERVICE_IP,
 	    ip_globals.client_connection);
 	if (ip_netif->phone < 0) {
Index: uspace/srv/net/il/ip/ip_module.c
===================================================================
--- uspace/srv/net/il/ip/ip_module.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/il/ip/ip_module.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -66,5 +66,5 @@
 int il_module_start_standalone(async_client_conn_t client_connection)
 {
-	ipcarg_t phonehash;
+	sysarg_t phonehash;
 	int rc;
 	
Index: uspace/srv/net/net/net.c
===================================================================
--- uspace/srv/net/net/net.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/net/net.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -322,5 +322,5 @@
 static int net_module_start(async_client_conn_t client_connection)
 {
-	ipcarg_t phonehash;
+	sysarg_t phonehash;
 	int rc;
 	
Index: uspace/srv/net/netif/lo/lo.c
===================================================================
--- uspace/srv/net/netif/lo/lo.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/netif/lo/lo.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -164,5 +164,5 @@
 int netif_initialize(void)
 {
-	ipcarg_t phonehash;
+	sysarg_t phonehash;
 
 	return REGISTER_ME(SERVICE_LO, &phonehash);
Index: uspace/srv/net/nil/eth/eth.c
===================================================================
--- uspace/srv/net/nil/eth/eth.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/nil/eth/eth.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -251,8 +251,8 @@
 				    IPC_GET_DEVICE(icall), packet, 0);
 			}
-			ipc_answer_0(iid, (ipcarg_t) rc);
+			ipc_answer_0(iid, (sysarg_t) rc);
 			break;
 		default:
-			ipc_answer_0(iid, (ipcarg_t) ENOTSUP);
+			ipc_answer_0(iid, (sysarg_t) ENOTSUP);
 		}
 		
Index: uspace/srv/net/nil/eth/eth_module.c
===================================================================
--- uspace/srv/net/nil/eth/eth_module.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/nil/eth/eth_module.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -52,5 +52,5 @@
 int nil_module_start_standalone(async_client_conn_t client_connection)
 {
-	ipcarg_t phonehash;
+	sysarg_t phonehash;
 	int rc;
 	
Index: uspace/srv/net/nil/nildummy/nildummy.c
===================================================================
--- uspace/srv/net/nil/nildummy/nildummy.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/nil/nildummy/nildummy.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -114,5 +114,5 @@
 			rc = nil_device_state_msg_local(0,
 			    IPC_GET_DEVICE(icall), IPC_GET_STATE(icall));
-			ipc_answer_0(iid, (ipcarg_t) rc);
+			ipc_answer_0(iid, (sysarg_t) rc);
 			break;
 		
@@ -124,9 +124,9 @@
 				    IPC_GET_DEVICE(icall), packet, 0);
 			}
-			ipc_answer_0(iid, (ipcarg_t) rc);
+			ipc_answer_0(iid, (sysarg_t) rc);
 			break;
 		
 		default:
-			ipc_answer_0(iid, (ipcarg_t) ENOTSUP);
+			ipc_answer_0(iid, (sysarg_t) ENOTSUP);
 		}
 		
Index: uspace/srv/net/nil/nildummy/nildummy_module.c
===================================================================
--- uspace/srv/net/nil/nildummy/nildummy_module.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/nil/nildummy/nildummy_module.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -52,5 +52,5 @@
 int nil_module_start_standalone(async_client_conn_t client_connection)
 {
-	ipcarg_t phonehash;
+	sysarg_t phonehash;
 	int rc;
 	
Index: uspace/srv/net/tl/icmp/icmp_module.c
===================================================================
--- uspace/srv/net/tl/icmp/icmp_module.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/tl/icmp/icmp_module.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -58,5 +58,5 @@
 int tl_module_start_standalone(async_client_conn_t client_connection)
 {
-	ipcarg_t phonehash;
+	sysarg_t phonehash;
 	int rc;
 
Index: uspace/srv/net/tl/tcp/tcp.c
===================================================================
--- uspace/srv/net/tl/tcp/tcp.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/tl/tcp/tcp.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -829,8 +829,8 @@
 	/* Notify the destination socket */
 	async_msg_5(socket->phone, NET_SOCKET_RECEIVED,
-	    (ipcarg_t) socket->socket_id,
+	    (sysarg_t) socket->socket_id,
 	    ((packet_dimension->content < socket_data->data_fragment_size) ?
 	    packet_dimension->content : socket_data->data_fragment_size), 0, 0,
-	    (ipcarg_t) fragments);
+	    (sysarg_t) fragments);
 
 	return EOK;
@@ -1090,7 +1090,7 @@
 			/* Notify the destination socket */
 			async_msg_5(socket->phone, NET_SOCKET_ACCEPTED,
-			    (ipcarg_t) listening_socket->socket_id,
+			    (sysarg_t) listening_socket->socket_id,
 			    socket_data->data_fragment_size, TCP_HEADER_SIZE,
-			    0, (ipcarg_t) socket->socket_id);
+			    0, (sysarg_t) socket->socket_id);
 
 			fibril_rwlock_write_unlock(socket_data->local_lock);
Index: uspace/srv/net/tl/tcp/tcp_module.c
===================================================================
--- uspace/srv/net/tl/tcp/tcp_module.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/tl/tcp/tcp_module.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -61,5 +61,5 @@
 int tl_module_start_standalone(async_client_conn_t client_connection)
 {
-	ipcarg_t phonehash;
+	sysarg_t phonehash;
 	int rc;
 
Index: uspace/srv/net/tl/udp/udp.c
===================================================================
--- uspace/srv/net/tl/udp/udp.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/tl/udp/udp.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -393,6 +393,6 @@
 	fibril_rwlock_write_unlock(&udp_globals.lock);
 	async_msg_5(socket->phone, NET_SOCKET_RECEIVED,
-	    (ipcarg_t) socket->socket_id, packet_dimension->content, 0, 0,
-	    (ipcarg_t) fragments);
+	    (sysarg_t) socket->socket_id, packet_dimension->content, 0, 0,
+	    (sysarg_t) fragments);
 
 	return EOK;
Index: uspace/srv/net/tl/udp/udp_module.c
===================================================================
--- uspace/srv/net/tl/udp/udp_module.c	(revision bea023b9b8202ba19f790a340e59e36be213fadf)
+++ uspace/srv/net/tl/udp/udp_module.c	(revision 96b02eb9b2f96f3843b8275c254c43a9cb6c8c88)
@@ -59,5 +59,5 @@
 int tl_module_start_standalone(async_client_conn_t client_connection)
 {
-	ipcarg_t phonehash;
+	sysarg_t phonehash;
 	int rc;
 